// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sas_msgs:msg/InformationFromMaster.idl
// generated code does not contain a copyright notice
#include "sas_msgs/msg/detail/information_from_master__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `twist`
#include "geometry_msgs/msg/detail/twist__functions.h"
// Member `sender_ip`
// Member `label`
#include "rosidl_runtime_c/string_functions.h"
// Member `additional_keys`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sas_msgs__msg__InformationFromMaster__init(sas_msgs__msg__InformationFromMaster * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // packet_version
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__init(&msg->twist)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // sender_ip
  if (!rosidl_runtime_c__String__init(&msg->sender_ip)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // sender_port
  // label
  if (!rosidl_runtime_c__String__init(&msg->label)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // clutch
  // additional_keys
  if (!rosidl_runtime_c__boolean__Sequence__init(&msg->additional_keys, 0)) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
    return false;
  }
  // motion_scaling
  // button
  // gripper
  return true;
}

void
sas_msgs__msg__InformationFromMaster__fini(sas_msgs__msg__InformationFromMaster * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // packet_version
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // twist
  geometry_msgs__msg__Twist__fini(&msg->twist);
  // sender_ip
  rosidl_runtime_c__String__fini(&msg->sender_ip);
  // sender_port
  // label
  rosidl_runtime_c__String__fini(&msg->label);
  // clutch
  // additional_keys
  rosidl_runtime_c__boolean__Sequence__fini(&msg->additional_keys);
  // motion_scaling
  // button
  // gripper
}

bool
sas_msgs__msg__InformationFromMaster__are_equal(const sas_msgs__msg__InformationFromMaster * lhs, const sas_msgs__msg__InformationFromMaster * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // packet_version
  if (lhs->packet_version != rhs->packet_version) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__are_equal(
      &(lhs->twist), &(rhs->twist)))
  {
    return false;
  }
  // sender_ip
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->sender_ip), &(rhs->sender_ip)))
  {
    return false;
  }
  // sender_port
  if (lhs->sender_port != rhs->sender_port) {
    return false;
  }
  // label
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->label), &(rhs->label)))
  {
    return false;
  }
  // clutch
  if (lhs->clutch != rhs->clutch) {
    return false;
  }
  // additional_keys
  if (!rosidl_runtime_c__boolean__Sequence__are_equal(
      &(lhs->additional_keys), &(rhs->additional_keys)))
  {
    return false;
  }
  // motion_scaling
  if (lhs->motion_scaling != rhs->motion_scaling) {
    return false;
  }
  // button
  if (lhs->button != rhs->button) {
    return false;
  }
  // gripper
  if (lhs->gripper != rhs->gripper) {
    return false;
  }
  return true;
}

bool
sas_msgs__msg__InformationFromMaster__copy(
  const sas_msgs__msg__InformationFromMaster * input,
  sas_msgs__msg__InformationFromMaster * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // packet_version
  output->packet_version = input->packet_version;
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__copy(
      &(input->twist), &(output->twist)))
  {
    return false;
  }
  // sender_ip
  if (!rosidl_runtime_c__String__copy(
      &(input->sender_ip), &(output->sender_ip)))
  {
    return false;
  }
  // sender_port
  output->sender_port = input->sender_port;
  // label
  if (!rosidl_runtime_c__String__copy(
      &(input->label), &(output->label)))
  {
    return false;
  }
  // clutch
  output->clutch = input->clutch;
  // additional_keys
  if (!rosidl_runtime_c__boolean__Sequence__copy(
      &(input->additional_keys), &(output->additional_keys)))
  {
    return false;
  }
  // motion_scaling
  output->motion_scaling = input->motion_scaling;
  // button
  output->button = input->button;
  // gripper
  output->gripper = input->gripper;
  return true;
}

sas_msgs__msg__InformationFromMaster *
sas_msgs__msg__InformationFromMaster__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationFromMaster * msg = (sas_msgs__msg__InformationFromMaster *)allocator.allocate(sizeof(sas_msgs__msg__InformationFromMaster), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sas_msgs__msg__InformationFromMaster));
  bool success = sas_msgs__msg__InformationFromMaster__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sas_msgs__msg__InformationFromMaster__destroy(sas_msgs__msg__InformationFromMaster * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sas_msgs__msg__InformationFromMaster__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sas_msgs__msg__InformationFromMaster__Sequence__init(sas_msgs__msg__InformationFromMaster__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationFromMaster * data = NULL;

  if (size) {
    data = (sas_msgs__msg__InformationFromMaster *)allocator.zero_allocate(size, sizeof(sas_msgs__msg__InformationFromMaster), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sas_msgs__msg__InformationFromMaster__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sas_msgs__msg__InformationFromMaster__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sas_msgs__msg__InformationFromMaster__Sequence__fini(sas_msgs__msg__InformationFromMaster__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sas_msgs__msg__InformationFromMaster__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sas_msgs__msg__InformationFromMaster__Sequence *
sas_msgs__msg__InformationFromMaster__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationFromMaster__Sequence * array = (sas_msgs__msg__InformationFromMaster__Sequence *)allocator.allocate(sizeof(sas_msgs__msg__InformationFromMaster__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sas_msgs__msg__InformationFromMaster__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sas_msgs__msg__InformationFromMaster__Sequence__destroy(sas_msgs__msg__InformationFromMaster__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sas_msgs__msg__InformationFromMaster__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sas_msgs__msg__InformationFromMaster__Sequence__are_equal(const sas_msgs__msg__InformationFromMaster__Sequence * lhs, const sas_msgs__msg__InformationFromMaster__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sas_msgs__msg__InformationFromMaster__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sas_msgs__msg__InformationFromMaster__Sequence__copy(
  const sas_msgs__msg__InformationFromMaster__Sequence * input,
  sas_msgs__msg__InformationFromMaster__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sas_msgs__msg__InformationFromMaster);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sas_msgs__msg__InformationFromMaster * data =
      (sas_msgs__msg__InformationFromMaster *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sas_msgs__msg__InformationFromMaster__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sas_msgs__msg__InformationFromMaster__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sas_msgs__msg__InformationFromMaster__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
