// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sas_msgs:msg/InformationFromMaster.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/information_from_master.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__TRAITS_HPP_
#define SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sas_msgs/msg/detail/information_from_master__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'twist'
#include "geometry_msgs/msg/detail/twist__traits.hpp"

namespace sas_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InformationFromMaster & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: packet_version
  {
    out << "packet_version: ";
    rosidl_generator_traits::value_to_yaml(msg.packet_version, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
    out << ", ";
  }

  // member: twist
  {
    out << "twist: ";
    to_flow_style_yaml(msg.twist, out);
    out << ", ";
  }

  // member: sender_ip
  {
    out << "sender_ip: ";
    rosidl_generator_traits::value_to_yaml(msg.sender_ip, out);
    out << ", ";
  }

  // member: sender_port
  {
    out << "sender_port: ";
    rosidl_generator_traits::value_to_yaml(msg.sender_port, out);
    out << ", ";
  }

  // member: label
  {
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
    out << ", ";
  }

  // member: clutch
  {
    out << "clutch: ";
    rosidl_generator_traits::value_to_yaml(msg.clutch, out);
    out << ", ";
  }

  // member: additional_keys
  {
    if (msg.additional_keys.size() == 0) {
      out << "additional_keys: []";
    } else {
      out << "additional_keys: [";
      size_t pending_items = msg.additional_keys.size();
      for (auto item : msg.additional_keys) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: motion_scaling
  {
    out << "motion_scaling: ";
    rosidl_generator_traits::value_to_yaml(msg.motion_scaling, out);
    out << ", ";
  }

  // member: button
  {
    out << "button: ";
    rosidl_generator_traits::value_to_yaml(msg.button, out);
    out << ", ";
  }

  // member: gripper
  {
    out << "gripper: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InformationFromMaster & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: packet_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "packet_version: ";
    rosidl_generator_traits::value_to_yaml(msg.packet_version, out);
    out << "\n";
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }

  // member: twist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "twist:\n";
    to_block_style_yaml(msg.twist, out, indentation + 2);
  }

  // member: sender_ip
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sender_ip: ";
    rosidl_generator_traits::value_to_yaml(msg.sender_ip, out);
    out << "\n";
  }

  // member: sender_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sender_port: ";
    rosidl_generator_traits::value_to_yaml(msg.sender_port, out);
    out << "\n";
  }

  // member: label
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "label: ";
    rosidl_generator_traits::value_to_yaml(msg.label, out);
    out << "\n";
  }

  // member: clutch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "clutch: ";
    rosidl_generator_traits::value_to_yaml(msg.clutch, out);
    out << "\n";
  }

  // member: additional_keys
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.additional_keys.size() == 0) {
      out << "additional_keys: []\n";
    } else {
      out << "additional_keys:\n";
      for (auto item : msg.additional_keys) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: motion_scaling
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "motion_scaling: ";
    rosidl_generator_traits::value_to_yaml(msg.motion_scaling, out);
    out << "\n";
  }

  // member: button
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "button: ";
    rosidl_generator_traits::value_to_yaml(msg.button, out);
    out << "\n";
  }

  // member: gripper
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gripper: ";
    rosidl_generator_traits::value_to_yaml(msg.gripper, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InformationFromMaster & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sas_msgs

namespace rosidl_generator_traits
{

[[deprecated("use sas_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sas_msgs::msg::InformationFromMaster & msg,
  std::ostream & out, size_t indentation = 0)
{
  sas_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sas_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const sas_msgs::msg::InformationFromMaster & msg)
{
  return sas_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sas_msgs::msg::InformationFromMaster>()
{
  return "sas_msgs::msg::InformationFromMaster";
}

template<>
inline const char * name<sas_msgs::msg::InformationFromMaster>()
{
  return "sas_msgs/msg/InformationFromMaster";
}

template<>
struct has_fixed_size<sas_msgs::msg::InformationFromMaster>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<sas_msgs::msg::InformationFromMaster>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<sas_msgs::msg::InformationFromMaster>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__TRAITS_HPP_
