// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sas_msgs:msg/InformationToMaster.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/information_to_master.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__INFORMATION_TO_MASTER__TRAITS_HPP_
#define SAS_MSGS__MSG__DETAIL__INFORMATION_TO_MASTER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sas_msgs/msg/detail/information_to_master__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'wrench'
#include "geometry_msgs/msg/detail/wrench__traits.hpp"

namespace sas_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const InformationToMaster & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: wrench
  {
    out << "wrench: ";
    to_flow_style_yaml(msg.wrench, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const InformationToMaster & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: wrench
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wrench:\n";
    to_block_style_yaml(msg.wrench, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const InformationToMaster & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sas_msgs

namespace rosidl_generator_traits
{

[[deprecated("use sas_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sas_msgs::msg::InformationToMaster & msg,
  std::ostream & out, size_t indentation = 0)
{
  sas_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sas_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const sas_msgs::msg::InformationToMaster & msg)
{
  return sas_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sas_msgs::msg::InformationToMaster>()
{
  return "sas_msgs::msg::InformationToMaster";
}

template<>
inline const char * name<sas_msgs::msg::InformationToMaster>()
{
  return "sas_msgs/msg/InformationToMaster";
}

template<>
struct has_fixed_size<sas_msgs::msg::InformationToMaster>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Wrench>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<sas_msgs::msg::InformationToMaster>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Wrench>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<sas_msgs::msg::InformationToMaster>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SAS_MSGS__MSG__DETAIL__INFORMATION_TO_MASTER__TRAITS_HPP_
