// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sas_msgs:msg/LogDatum.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/log_datum.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__LOG_DATUM__TRAITS_HPP_
#define SAS_MSGS__MSG__DETAIL__LOG_DATUM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sas_msgs/msg/detail/log_datum__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sas_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LogDatum & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: layout
  {
    if (msg.layout.size() == 0) {
      out << "layout: []";
    } else {
      out << "layout: [";
      size_t pending_items = msg.layout.size();
      for (auto item : msg.layout) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: value
  {
    if (msg.value.size() == 0) {
      out << "value: []";
    } else {
      out << "value: [";
      size_t pending_items = msg.value.size();
      for (auto item : msg.value) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: strvalue
  {
    out << "strvalue: ";
    rosidl_generator_traits::value_to_yaml(msg.strvalue, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LogDatum & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: layout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.layout.size() == 0) {
      out << "layout: []\n";
    } else {
      out << "layout:\n";
      for (auto item : msg.layout) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.value.size() == 0) {
      out << "value: []\n";
    } else {
      out << "value:\n";
      for (auto item : msg.value) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: strvalue
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "strvalue: ";
    rosidl_generator_traits::value_to_yaml(msg.strvalue, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LogDatum & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sas_msgs

namespace rosidl_generator_traits
{

[[deprecated("use sas_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sas_msgs::msg::LogDatum & msg,
  std::ostream & out, size_t indentation = 0)
{
  sas_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sas_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const sas_msgs::msg::LogDatum & msg)
{
  return sas_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sas_msgs::msg::LogDatum>()
{
  return "sas_msgs::msg::LogDatum";
}

template<>
inline const char * name<sas_msgs::msg::LogDatum>()
{
  return "sas_msgs/msg/LogDatum";
}

template<>
struct has_fixed_size<sas_msgs::msg::LogDatum>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<sas_msgs::msg::LogDatum>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<sas_msgs::msg::LogDatum>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SAS_MSGS__MSG__DETAIL__LOG_DATUM__TRAITS_HPP_
