// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sas_msgs:msg/InformationFromMaster.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/information_from_master.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__STRUCT_HPP_
#define SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'twist'
#include "geometry_msgs/msg/detail/twist__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__sas_msgs__msg__InformationFromMaster __attribute__((deprecated))
#else
# define DEPRECATED__sas_msgs__msg__InformationFromMaster __declspec(deprecated)
#endif

namespace sas_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InformationFromMaster_
{
  using Type = InformationFromMaster_<ContainerAllocator>;

  explicit InformationFromMaster_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    pose(_init),
    twist(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->packet_version = 0l;
      this->sender_ip = "";
      this->sender_port = 0l;
      this->label = "";
      this->clutch = false;
      this->motion_scaling = 0.0;
      this->button = 0.0;
      this->gripper = 0.0;
    }
  }

  explicit InformationFromMaster_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    pose(_alloc, _init),
    twist(_alloc, _init),
    sender_ip(_alloc),
    label(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->packet_version = 0l;
      this->sender_ip = "";
      this->sender_port = 0l;
      this->label = "";
      this->clutch = false;
      this->motion_scaling = 0.0;
      this->button = 0.0;
      this->gripper = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _packet_version_type =
    int32_t;
  _packet_version_type packet_version;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _twist_type =
    geometry_msgs::msg::Twist_<ContainerAllocator>;
  _twist_type twist;
  using _sender_ip_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _sender_ip_type sender_ip;
  using _sender_port_type =
    int32_t;
  _sender_port_type sender_port;
  using _label_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _label_type label;
  using _clutch_type =
    bool;
  _clutch_type clutch;
  using _additional_keys_type =
    std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>>;
  _additional_keys_type additional_keys;
  using _motion_scaling_type =
    double;
  _motion_scaling_type motion_scaling;
  using _button_type =
    double;
  _button_type button;
  using _gripper_type =
    double;
  _gripper_type gripper;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__packet_version(
    const int32_t & _arg)
  {
    this->packet_version = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__twist(
    const geometry_msgs::msg::Twist_<ContainerAllocator> & _arg)
  {
    this->twist = _arg;
    return *this;
  }
  Type & set__sender_ip(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->sender_ip = _arg;
    return *this;
  }
  Type & set__sender_port(
    const int32_t & _arg)
  {
    this->sender_port = _arg;
    return *this;
  }
  Type & set__label(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->label = _arg;
    return *this;
  }
  Type & set__clutch(
    const bool & _arg)
  {
    this->clutch = _arg;
    return *this;
  }
  Type & set__additional_keys(
    const std::vector<bool, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<bool>> & _arg)
  {
    this->additional_keys = _arg;
    return *this;
  }
  Type & set__motion_scaling(
    const double & _arg)
  {
    this->motion_scaling = _arg;
    return *this;
  }
  Type & set__button(
    const double & _arg)
  {
    this->button = _arg;
    return *this;
  }
  Type & set__gripper(
    const double & _arg)
  {
    this->gripper = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sas_msgs::msg::InformationFromMaster_<ContainerAllocator> *;
  using ConstRawPtr =
    const sas_msgs::msg::InformationFromMaster_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sas_msgs::msg::InformationFromMaster_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sas_msgs::msg::InformationFromMaster_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sas_msgs__msg__InformationFromMaster
    std::shared_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sas_msgs__msg__InformationFromMaster
    std::shared_ptr<sas_msgs::msg::InformationFromMaster_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InformationFromMaster_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->packet_version != other.packet_version) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->twist != other.twist) {
      return false;
    }
    if (this->sender_ip != other.sender_ip) {
      return false;
    }
    if (this->sender_port != other.sender_port) {
      return false;
    }
    if (this->label != other.label) {
      return false;
    }
    if (this->clutch != other.clutch) {
      return false;
    }
    if (this->additional_keys != other.additional_keys) {
      return false;
    }
    if (this->motion_scaling != other.motion_scaling) {
      return false;
    }
    if (this->button != other.button) {
      return false;
    }
    if (this->gripper != other.gripper) {
      return false;
    }
    return true;
  }
  bool operator!=(const InformationFromMaster_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InformationFromMaster_

// alias to use template instance with default allocator
using InformationFromMaster =
  sas_msgs::msg::InformationFromMaster_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sas_msgs

#endif  // SAS_MSGS__MSG__DETAIL__INFORMATION_FROM_MASTER__STRUCT_HPP_
