// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sas_msgs:msg/InformationToMaster.idl
// generated code does not contain a copyright notice
#include "sas_msgs/msg/detail/information_to_master__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `wrench`
#include "geometry_msgs/msg/detail/wrench__functions.h"

bool
sas_msgs__msg__InformationToMaster__init(sas_msgs__msg__InformationToMaster * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    sas_msgs__msg__InformationToMaster__fini(msg);
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__init(&msg->wrench)) {
    sas_msgs__msg__InformationToMaster__fini(msg);
    return false;
  }
  return true;
}

void
sas_msgs__msg__InformationToMaster__fini(sas_msgs__msg__InformationToMaster * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // wrench
  geometry_msgs__msg__Wrench__fini(&msg->wrench);
}

bool
sas_msgs__msg__InformationToMaster__are_equal(const sas_msgs__msg__InformationToMaster * lhs, const sas_msgs__msg__InformationToMaster * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__are_equal(
      &(lhs->wrench), &(rhs->wrench)))
  {
    return false;
  }
  return true;
}

bool
sas_msgs__msg__InformationToMaster__copy(
  const sas_msgs__msg__InformationToMaster * input,
  sas_msgs__msg__InformationToMaster * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__copy(
      &(input->wrench), &(output->wrench)))
  {
    return false;
  }
  return true;
}

sas_msgs__msg__InformationToMaster *
sas_msgs__msg__InformationToMaster__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationToMaster * msg = (sas_msgs__msg__InformationToMaster *)allocator.allocate(sizeof(sas_msgs__msg__InformationToMaster), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sas_msgs__msg__InformationToMaster));
  bool success = sas_msgs__msg__InformationToMaster__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sas_msgs__msg__InformationToMaster__destroy(sas_msgs__msg__InformationToMaster * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sas_msgs__msg__InformationToMaster__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sas_msgs__msg__InformationToMaster__Sequence__init(sas_msgs__msg__InformationToMaster__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationToMaster * data = NULL;

  if (size) {
    data = (sas_msgs__msg__InformationToMaster *)allocator.zero_allocate(size, sizeof(sas_msgs__msg__InformationToMaster), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sas_msgs__msg__InformationToMaster__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sas_msgs__msg__InformationToMaster__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sas_msgs__msg__InformationToMaster__Sequence__fini(sas_msgs__msg__InformationToMaster__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sas_msgs__msg__InformationToMaster__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sas_msgs__msg__InformationToMaster__Sequence *
sas_msgs__msg__InformationToMaster__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__InformationToMaster__Sequence * array = (sas_msgs__msg__InformationToMaster__Sequence *)allocator.allocate(sizeof(sas_msgs__msg__InformationToMaster__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sas_msgs__msg__InformationToMaster__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sas_msgs__msg__InformationToMaster__Sequence__destroy(sas_msgs__msg__InformationToMaster__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sas_msgs__msg__InformationToMaster__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sas_msgs__msg__InformationToMaster__Sequence__are_equal(const sas_msgs__msg__InformationToMaster__Sequence * lhs, const sas_msgs__msg__InformationToMaster__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sas_msgs__msg__InformationToMaster__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sas_msgs__msg__InformationToMaster__Sequence__copy(
  const sas_msgs__msg__InformationToMaster__Sequence * input,
  sas_msgs__msg__InformationToMaster__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sas_msgs__msg__InformationToMaster);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sas_msgs__msg__InformationToMaster * data =
      (sas_msgs__msg__InformationToMaster *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sas_msgs__msg__InformationToMaster__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sas_msgs__msg__InformationToMaster__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sas_msgs__msg__InformationToMaster__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
