// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from sas_msgs:msg/LogDatum.idl
// generated code does not contain a copyright notice
#include "sas_msgs/msg/detail/log_datum__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `strvalue`
#include "rosidl_runtime_c/string_functions.h"
// Member `layout`
// Member `value`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
sas_msgs__msg__LogDatum__init(sas_msgs__msg__LogDatum * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    sas_msgs__msg__LogDatum__fini(msg);
    return false;
  }
  // layout
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->layout, 0)) {
    sas_msgs__msg__LogDatum__fini(msg);
    return false;
  }
  // value
  if (!rosidl_runtime_c__double__Sequence__init(&msg->value, 0)) {
    sas_msgs__msg__LogDatum__fini(msg);
    return false;
  }
  // strvalue
  if (!rosidl_runtime_c__String__init(&msg->strvalue)) {
    sas_msgs__msg__LogDatum__fini(msg);
    return false;
  }
  return true;
}

void
sas_msgs__msg__LogDatum__fini(sas_msgs__msg__LogDatum * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // layout
  rosidl_runtime_c__int32__Sequence__fini(&msg->layout);
  // value
  rosidl_runtime_c__double__Sequence__fini(&msg->value);
  // strvalue
  rosidl_runtime_c__String__fini(&msg->strvalue);
}

bool
sas_msgs__msg__LogDatum__are_equal(const sas_msgs__msg__LogDatum * lhs, const sas_msgs__msg__LogDatum * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // layout
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->layout), &(rhs->layout)))
  {
    return false;
  }
  // value
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->value), &(rhs->value)))
  {
    return false;
  }
  // strvalue
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->strvalue), &(rhs->strvalue)))
  {
    return false;
  }
  return true;
}

bool
sas_msgs__msg__LogDatum__copy(
  const sas_msgs__msg__LogDatum * input,
  sas_msgs__msg__LogDatum * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // layout
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->layout), &(output->layout)))
  {
    return false;
  }
  // value
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->value), &(output->value)))
  {
    return false;
  }
  // strvalue
  if (!rosidl_runtime_c__String__copy(
      &(input->strvalue), &(output->strvalue)))
  {
    return false;
  }
  return true;
}

sas_msgs__msg__LogDatum *
sas_msgs__msg__LogDatum__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__LogDatum * msg = (sas_msgs__msg__LogDatum *)allocator.allocate(sizeof(sas_msgs__msg__LogDatum), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(sas_msgs__msg__LogDatum));
  bool success = sas_msgs__msg__LogDatum__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
sas_msgs__msg__LogDatum__destroy(sas_msgs__msg__LogDatum * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    sas_msgs__msg__LogDatum__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
sas_msgs__msg__LogDatum__Sequence__init(sas_msgs__msg__LogDatum__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__LogDatum * data = NULL;

  if (size) {
    data = (sas_msgs__msg__LogDatum *)allocator.zero_allocate(size, sizeof(sas_msgs__msg__LogDatum), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = sas_msgs__msg__LogDatum__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        sas_msgs__msg__LogDatum__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
sas_msgs__msg__LogDatum__Sequence__fini(sas_msgs__msg__LogDatum__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      sas_msgs__msg__LogDatum__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

sas_msgs__msg__LogDatum__Sequence *
sas_msgs__msg__LogDatum__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  sas_msgs__msg__LogDatum__Sequence * array = (sas_msgs__msg__LogDatum__Sequence *)allocator.allocate(sizeof(sas_msgs__msg__LogDatum__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = sas_msgs__msg__LogDatum__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
sas_msgs__msg__LogDatum__Sequence__destroy(sas_msgs__msg__LogDatum__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    sas_msgs__msg__LogDatum__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
sas_msgs__msg__LogDatum__Sequence__are_equal(const sas_msgs__msg__LogDatum__Sequence * lhs, const sas_msgs__msg__LogDatum__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!sas_msgs__msg__LogDatum__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
sas_msgs__msg__LogDatum__Sequence__copy(
  const sas_msgs__msg__LogDatum__Sequence * input,
  sas_msgs__msg__LogDatum__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(sas_msgs__msg__LogDatum);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    sas_msgs__msg__LogDatum * data =
      (sas_msgs__msg__LogDatum *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!sas_msgs__msg__LogDatum__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          sas_msgs__msg__LogDatum__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!sas_msgs__msg__LogDatum__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
