// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from sas_msgs:msg/LogDatum.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/log_datum.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__LOG_DATUM__STRUCT_HPP_
#define SAS_MSGS__MSG__DETAIL__LOG_DATUM__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__sas_msgs__msg__LogDatum __attribute__((deprecated))
#else
# define DEPRECATED__sas_msgs__msg__LogDatum __declspec(deprecated)
#endif

namespace sas_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct LogDatum_
{
  using Type = LogDatum_<ContainerAllocator>;

  explicit LogDatum_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->strvalue = "";
    }
  }

  explicit LogDatum_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc),
    strvalue(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->strvalue = "";
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _layout_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _layout_type layout;
  using _value_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _value_type value;
  using _strvalue_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _strvalue_type strvalue;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__layout(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->layout = _arg;
    return *this;
  }
  Type & set__value(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__strvalue(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->strvalue = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    sas_msgs::msg::LogDatum_<ContainerAllocator> *;
  using ConstRawPtr =
    const sas_msgs::msg::LogDatum_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      sas_msgs::msg::LogDatum_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      sas_msgs::msg::LogDatum_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__sas_msgs__msg__LogDatum
    std::shared_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__sas_msgs__msg__LogDatum
    std::shared_ptr<sas_msgs::msg::LogDatum_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LogDatum_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->layout != other.layout) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    if (this->strvalue != other.strvalue) {
      return false;
    }
    return true;
  }
  bool operator!=(const LogDatum_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LogDatum_

// alias to use template instance with default allocator
using LogDatum =
  sas_msgs::msg::LogDatum_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace sas_msgs

#endif  // SAS_MSGS__MSG__DETAIL__LOG_DATUM__STRUCT_HPP_
