// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from sas_msgs:msg/String.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "sas_msgs/msg/string.hpp"


#ifndef SAS_MSGS__MSG__DETAIL__STRING__TRAITS_HPP_
#define SAS_MSGS__MSG__DETAIL__STRING__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "sas_msgs/msg/detail/string__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace sas_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const String & msg,
  std::ostream & out)
{
  out << "{";
  // member: data
  {
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const String & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const String & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace sas_msgs

namespace rosidl_generator_traits
{

[[deprecated("use sas_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const sas_msgs::msg::String & msg,
  std::ostream & out, size_t indentation = 0)
{
  sas_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use sas_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const sas_msgs::msg::String & msg)
{
  return sas_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<sas_msgs::msg::String>()
{
  return "sas_msgs::msg::String";
}

template<>
inline const char * name<sas_msgs::msg::String>()
{
  return "sas_msgs/msg/String";
}

template<>
struct has_fixed_size<sas_msgs::msg::String>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<sas_msgs::msg::String>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<sas_msgs::msg::String>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SAS_MSGS__MSG__DETAIL__STRING__TRAITS_HPP_
